#!/usr/bin/perl

$squid_log="/var/log/squid/access.log";
$dialup_ipmask="^192\.168\.225\.";

my $sum_ANY_PARENT=0;
my $sum_DEFAULT_PARENT=0;
my $sum_DIRECT=0;
my $sum_NONE=0;
my $sum_UNKNOWN=0;

my $sum_ANY_PARENT_bw=0;
my $sum_DEFAULT_PARENT_bw=0;
my $sum_DIRECT_bw=0;
my $sum_NONE_bw=0;
my $sum_UNKNOWN_bw=0;

my $sum_ANY_PARENT_cnt=0;
my $sum_DEFAULT_PARENT_cnt=0;
my $sum_DIRECT_cnt=0;
my $sum_NONE_cnt=0;
my $sum_UNKNOWN_cnt=0;

my $now_time = time();
my $timelimit = $ARGV[0] * 60 || $now_time;

open (LOG, "<$squid_log") || die "Cant' open log $squid_log";
while(<LOG>){
    my ($s_time, $s_msec, $s_ip, $s_type, $s_size, $s_method, 
        $s_url, $s_hz, $s_proxy_status, $s_mime)=split(/\s+/);

    if ($now_time - $timelimit > $s_time){
	next;
    }

    if ($s_proxy_status =~ /^ANY_PARENT/ || $s_proxy_status =~ /^FIRST_UP_PARENT/){
	$sum_ANY_PARENT +=$s_size;
	$sum_ANY_PARENT_cnt++;
	if ($s_size > 0){
	    $sum_ANY_PARENT_bw += $s_msec;
	}
    } elsif ($s_proxy_status =~ /^DEFAULT_PARENT/){
	$sum_DEFAULT_PARENT +=$s_size;
	$sum_DEFAULT_PARENT_cnt++;
	if ($s_size > 0){
	    $sum_DEFAULT_PARENT_bw += $s_msec;
	}
    } elsif ($s_proxy_status =~ /^DIRECT/){
	$sum_DIRECT +=$s_size;
	$sum_DIRECT_cnt++;
	if ($s_size > 0){
	    $sum_DIRECT_bw += $s_msec;
	}
    } elsif ($s_proxy_status =~ /^NONE/ &&  $s_type =~ /HIT/){
	$sum_NONE +=$s_size;
	$sum_NONE_cnt++;
	if ($s_size > 0){
	    $sum_NONE_bw +=$s_msec;
	}
    } else {
	$sum_UNKNOWN +=$s_size;
	$sum_UNKNOWN_cnt++;
	if ($s_size > 0){
	    $sum_UNKNOWN_bw += $s_msec;
	}
    }
}
close(LOG);

$sum_ANY_PARENT_mb= int ($sum_ANY_PARENT/(1024*1024));
$sum_DEFAULT_PARENT_mb= int ($sum_DEFAULT_PARENT/(1024*1024));
$sum_DIRECT_mb= int ($sum_DIRECT/(1024*1024));
$sum_NONE_mb= int ($sum_NONE/(1024*1024));
$sum_UNKNOWN_mb= int ($sum_UNKNOWN/(1024*1024));

$sum_ANY_PARENT_bw=calc_bw($sum_ANY_PARENT_bw, $sum_ANY_PARENT, $sum_ANY_PARENT_cnt);
$sum_DEFAULT_PARENT_bw=calc_bw($sum_DEFAULT_PARENT_bw, $sum_DEFAULT_PARENT, $sum_DEFAULT_PARENT_cnt);
$sum_DIRECT_bw=calc_bw($sum_DIRECT_bw, $sum_DIRECT, $sum_DIRECT_cnt);
$sum_NONE_bw=calc_bw($sum_NONE_bw, $sum_NONE, $sum_NONE_cnt);
$sum_UNKNOWN_bw=calc_bw($sum_UNKNOWN_bw, $sum_UNKNOWN, $sum_UNKNOWN_cnt);

print "ANY_PARENT    = $sum_ANY_PARENT_mb Mb,\tcnt = $sum_ANY_PARENT_cnt,\tbw = $sum_ANY_PARENT_bw Kb/sec\n";
print "DEFAULT_PARENT= $sum_DEFAULT_PARENT_mb Mb,\tcnt = $sum_DEFAULT_PARENT_cnt,\tbw = $sum_DEFAULT_PARENT_bw Kb/sec\n";
print "DIRECT        = $sum_DIRECT_mb Mb,\tcnt = $sum_DIRECT_cnt,\tbw = $sum_DIRECT_bw Kb/sec\n";
print "NONE          = $sum_NONE_mb Mb,\tcnt = $sum_NONE_cnt,\tbw = $sum_NONE_bw Kb/sec\n";
print "UNKNOWN      = $sum_UNKNOWN_mb Mb,\tcnt = $sum_UNKNOWN_cnt,\tbw =  $sum_UNKNOWN_bw Kb/sec\n";

exit;

#########################################################################

sub calc_bw{
    my ($time, $size, $cnt) = @_;
    my $result1, $result2;

    $time = $time / 10000; #  .
    $size = $size / 1024; #  .
    $result1 = int($size/$time);
#    $result2 = int(($size/$cnt)/($time/$cnt));
    return $result1;
}
