#!/usr/bin/perl

#     .
# Copyright (c) 2003 by Maxim Chirkov <mc@tyumen.ru>


use strict;

my $cfg_net_int = "eth1";	#     .
my $cfg_max_ok_link_bw = 50000; #     .
my $cfg_max_rand_lenght = 1000; #   , ..   0  1000     .
my $cfg_stat_file = "/etc/squid/sat_balancer/prio.txt";
my $cfg_proc_inet_stat = "/proc/net/dev";
#      .
my @cfg_test_cmd = ("/usr/bin/curl", "--proxy", "sat-proxy.test.ru:3128", "--max-time", "10", "--silent", "http://usrstat.spacegate.com/", "-o", "/dev/null"); 

my $now_traf_in = -1;
my $now_traf_out = -1;
my $now_time = time();
my $now_time_str= localtime($now_time);
my $last_traf_in = -1;
my $last_traf_out = -1;
my $last_time = $now_time;
my ($bw_in, $bw_out);
my $rand_ok = 0;

#    .
open(STAT, "<$cfg_proc_inet_stat") || die "Can't open $cfg_proc_inet_stat";
while(<STAT>){
    chomp;
    if (/^[\s\t]*$cfg_net_int\:[\s\t]*(.*)$/){
	($now_traf_in,undef,undef,undef,undef,undef,undef,undef,$now_traf_out,undef,undef,undef,undef,undef,undef,undef) = split(/[\t\s]+/,$1);
	last;
    }
}
close(STAT);

#        .
if (-f "$cfg_stat_file.int"){
    $last_time = (stat("$cfg_stat_file.int"))[9];
    open(LAST, "<$cfg_stat_file.int");
    flock(LAST,1);
    if (my $cur_cnt = <LAST>){
	chomp($cur_cnt);
	($last_traf_in, $last_traf_out) = split(/\t/,$cur_cnt);
    }
    close(LAST);
}
#     last-.
open(LAST, ">$cfg_stat_file.int.tmp");
flock(LAST,2);
print LAST "$now_traf_in\t$now_traf_out\n";
close(LAST);
rename("$cfg_stat_file.int.tmp", "$cfg_stat_file.int");

#     /.
$bw_in = int (($now_traf_in - $last_traf_in)/($now_time - $last_time + 1));
$bw_out = int (($now_traf_out - $last_traf_out)/($now_time - $last_time + 1));

my $tmp = $now_traf_in - $last_traf_in;
# print "$bw_in ($tmp)/$bw_out\n";

# -------   :
#   .
my $ret_code = system(@cfg_test_cmd);
if ($ret_code != 0){
    $rand_ok=0;$cfg_max_rand_lenght=0; 
    print "$now_time_str:TEST CMD FAILED: $ret_code\n";
} elsif ($now_traf_in !~ /^\d+$/ || $now_traf_out !~ /^\d+$/ || $last_traf_in !~ /^\d+$/ || $last_traf_out !~ /^\d+$/){

#     -1, 
#     
    $rand_ok=0;$cfg_max_rand_lenght=0; 
    print "$now_time_str:COUNTER ERROR (first time ?): IN: $now_traf_in - $last_traf_in, OUT: $now_traf_out - $last_traf_out\n";
} elsif ($bw_in < 0 || $bw_out < 0){

#     .
    $rand_ok=0;$cfg_max_rand_lenght=0;
    print "$now_time_str:BW COUNTER OVERFLOW: IN: $bw_in, OUT: $bw_out\n";
} else {
    # OK.
    $rand_ok = int($cfg_max_rand_lenght * $cfg_max_ok_link_bw / ($bw_in+1));
}

#    .
open(CNT, ">$cfg_stat_file.tmp");
flock(CNT,2);
print CNT "$rand_ok\t$cfg_max_rand_lenght\n";
close(CNT);
rename("$cfg_stat_file.tmp", "$cfg_stat_file");
